package moe.gensoukyo.haloshield.client

import moe.gensoukyo.haloshield.SpartanShieldsMod
import moe.gensoukyo.haloshield.common.api.SpartanShieldApi
import net.minecraftforge.event.entity.living.LivingAttackEvent
import net.minecraftforge.event.entity.living.LivingEvent
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly

@SideOnly(Side.CLIENT)
@Mod.EventBusSubscriber(value = [Side.CLIENT], modid = SpartanShieldsMod.MODID)
object ClientEventHandler {
    @JvmStatic
    @SubscribeEvent
    fun onBeAttacked(e: LivingAttackEvent) {
        if (e.isServer) return

        SpartanShieldApi.getShieldData(e.entityLiving).resetRecoverTime()
    }

    @JvmStatic
    @SubscribeEvent
    fun onTick(e: LivingEvent.LivingUpdateEvent) {
        if (e.isServer) return

        // 取消客户端实体的红色闪光效果
        if (SpartanShieldApi.getShieldData(e.entityLiving).hasShield()) {
            if (e.entityLiving.hurtTime > 0) {
                e.entityLiving.hurtTime = 0
            }
        }
    }

    private val LivingEvent.isServer get() = !this.entity.world.isRemote
}