package moe.gensoukyo.haloshield.client.api;

import net.minecraft.client.model.ModelRenderer;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

/**
 * @author ChloePrime
 */
@SideOnly(Side.CLIENT)
public interface IMixinModelRenderer {
    /**
     * 获取上一次渲染时的scale
     * @return 上一次渲染时的scale
     */
    float getLastScale();

    /**
     * 获取是否需要渲染护盾
     * 只有这个 {@link ModelRenderer} 被渲染过以后
     * 才需要渲染护盾
     * @return 这tick模型是否被渲染，同时意味着是否渲染护盾
     */
    boolean getShouldRenderShield();

    /**
     * 传入本次渲染是否需要渲染护盾
     * 只有在成功渲染时才会渲染护盾
     * @param rendered 本次渲染是否需要渲染护盾
     */
    void setShouldRenderShield(boolean rendered);
}
