package moe.gensoukyo.haloshield.client.compat.cnpc

import moe.gensoukyo.haloshield.ModIds
import moe.gensoukyo.haloshield.SpartanShieldsMod
import moe.gensoukyo.haloshield.client.event.GenerateShieldRendererEvent
import moe.gensoukyo.haloshield.client.model.IntrusiveEShieldModel
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.Optional
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly
import noppes.npcs.client.model.ModelNpcCrystal
import noppes.npcs.client.model.ModelNpcDragon
import noppes.npcs.entity.EntityNpcCrystal
import noppes.npcs.entity.EntityNpcDragon

@SideOnly(Side.CLIENT)
@Mod.EventBusSubscriber(value = [Side.CLIENT], modid = SpartanShieldsMod.MODID)
object NpcCrystalListener {
    private const val scale = 0.0625f
    @JvmStatic
    @SubscribeEvent
    @Optional.Method(modid = ModIds.CNPC)
    fun onCrystal(e: GenerateShieldRendererEvent<EntityNpcCrystal>) {
        e.modelOverride = IntrusiveEShieldModel(ModelNpcCrystal(scale))
    }
    @JvmStatic
    @SubscribeEvent
    @Optional.Method(modid = ModIds.CNPC)
    fun onDragon(e: GenerateShieldRendererEvent<EntityNpcDragon>) {
        e.modelOverride = IntrusiveEShieldModel(ModelNpcDragon(scale))
    }
}