package moe.gensoukyo.haloshield.client.compat.tlm

import com.github.tartaricacid.touhoulittlemaid.client.renderer.entity.EntityCustomNpcChangeRender
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid
import moe.gensoukyo.haloshield.ModIds
import moe.gensoukyo.haloshield.SpartanShieldsMod
import moe.gensoukyo.haloshield.client.compat.cnpc.AbstractNpcEnergyShield
import moe.gensoukyo.haloshield.client.event.GenerateShieldRendererEvent
import moe.gensoukyo.haloshield.client.model.EnergyShieldModel
import net.minecraft.client.model.ModelBase
import net.minecraftforge.fml.common.Loader
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.Optional
import net.minecraftforge.fml.common.eventhandler.EventPriority
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly
import noppes.npcs.entity.EntityCustomNpc
import java.lang.reflect.Field

typealias E = EntityCustomNpc
typealias R = EntityCustomNpcChangeRender<E>

@SideOnly(Side.CLIENT)
class NpcEnergyShieldTLM(
    npcRenderer: R,
    shieldModel: ModelBase
): AbstractNpcEnergyShield<E, R>(E::class.java, npcRenderer, shieldModel) {

    override val fieldEntity: Field = EntityCustomNpcChangeRender::class.java
        .getDeclaredField("entity").apply { isAccessible = true }
    override val fieldRenderEntity: Field = EntityCustomNpcChangeRender::class.java
        .getDeclaredField("renderEntity").apply { isAccessible = true }

}

@SideOnly(Side.CLIENT)
@Mod.EventBusSubscriber(value = [Side.CLIENT], modid = SpartanShieldsMod.MODID)
object Listener {
    @JvmStatic
    @Optional.Method(modid = ModIds.CNPC)
    @SubscribeEvent(priority = EventPriority.HIGH)
    fun onShieldModel(e: GenerateShieldRendererEvent<EntityCustomNpc>) {
        if (Loader.isModLoaded(ModIds.TLM)) {
            onShieldModel0(e)
            e.isCanceled = true
        }
    }

    /**
     * 这个方法只有在女仆mod和CNPC同时存在时才会调用
     */
    @Optional.Method(modid = ModIds.TLM)
    fun onShieldModel0(e: GenerateShieldRendererEvent<EntityCustomNpc>) {
        val renderer = e.entityRenderer as? EntityCustomNpcChangeRender<EntityCustomNpc> ?: return
        e.rendererOverride = NpcEnergyShieldTLM(renderer, EnergyShieldModel(renderer.mainModel))
    }
}