package moe.gensoukyo.haloshield.client.compat.vanilla

import moe.gensoukyo.haloshield.SpartanShieldsMod
import moe.gensoukyo.haloshield.client.event.GenerateShieldRendererEvent
import moe.gensoukyo.haloshield.client.model.EnergyShieldModel
import net.minecraft.client.model.ModelBase
import net.minecraft.client.renderer.GlStateManager
import net.minecraft.entity.Entity
import net.minecraft.entity.monster.EntityGhast
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly
import org.lwjgl.util.vector.Vector3f

/**
 * 渲染时带有位置偏移的护盾模型
 * 例：恶魂的渲染偏移了 (0, 0.6, 0)
 */
@SideOnly(Side.CLIENT)
class OffsetShieldModel(
    private val offset: Vector3f ,delegate: ModelBase): EnergyShieldModel(delegate) {
    override fun render(
        entityIn: Entity,
        limbSwing: Float,
        limbSwingAmount: Float,
        ageInTicks: Float,
        netHeadYaw: Float,
        headPitch: Float,
        scale: Float
    ) {
        GlStateManager.translate(offset.x, offset.y, offset.z)
        super.render(entityIn, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale)
    }
}

@SideOnly(Side.CLIENT)
@Mod.EventBusSubscriber(value = [Side.CLIENT], modid = SpartanShieldsMod.MODID)
object OffsetListener {
    @JvmStatic
    @SubscribeEvent
    fun onModelAttach(e: GenerateShieldRendererEvent<EntityGhast>) {
        e.modelOverride = OffsetShieldModel(Vector3f(0f, 0.6f, 0f), e.entityModel)
    }
}