package moe.gensoukyo.haloshield.client.compat.vanilla

import moe.gensoukyo.haloshield.SpartanShieldsMod
import moe.gensoukyo.haloshield.client.event.GenerateShieldRendererEvent
import net.minecraft.client.model.ModelBase
import net.minecraft.client.model.ModelRenderer
import net.minecraft.entity.Entity
import net.minecraft.entity.monster.EntitySlime
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly

@SideOnly(Side.CLIENT)
class SlimeShieldModel: ModelBase() {
    private val shieldBox = ModelRenderer(this, 0, 0)

    init {
        val shieldSize = 9

        val halfSize = shieldSize / 2f
        val centerY = 20
        shieldBox.addBox(-halfSize, centerY - halfSize, -halfSize, shieldSize, shieldSize, shieldSize)
    }

    override fun render(
        entityIn: Entity,
        limbSwing: Float,
        limbSwingAmount: Float,
        ageInTicks: Float,
        netHeadYaw: Float,
        headPitch: Float,
        scale: Float
    ) {
        super.render(entityIn, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale)
        shieldBox.render(scale)
    }
}

@SideOnly(Side.CLIENT)
@Mod.EventBusSubscriber(value = [Side.CLIENT], modid = SpartanShieldsMod.MODID)
object SlimeListener {
    @JvmStatic
    @SubscribeEvent
    fun onModelAttach(e: GenerateShieldRendererEvent<EntitySlime>) {
        e.modelOverride = SlimeShieldModel()
    }
}