package moe.gensoukyo.haloshield.client.event

import moe.gensoukyo.haloshield.client.renderer.RenderEnergyShield
import net.minecraft.client.model.ModelBase
import net.minecraft.client.renderer.entity.RenderLivingBase
import net.minecraft.entity.EntityLivingBase
import net.minecraftforge.fml.common.eventhandler.Cancelable
import net.minecraftforge.fml.common.eventhandler.GenericEvent
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly

/**
 * 为生物模型生成护盾时发送的事件
 * 允许为不同种类的生物附加专用的护盾模型
 */
@Cancelable
@SideOnly(Side.CLIENT)
class GenerateShieldRendererEvent<E: EntityLivingBase>(
    val entityClass: Class<E>,
    val entityRenderer: RenderLivingBase<E>,
    val entityModel: ModelBase,
    var rendererOverride: RenderEnergyShield<in E>? = null,
    var modelOverride: ModelBase? = null,
    var noModel: Boolean = false
): GenericEvent<E>(entityClass)