package moe.gensoukyo.haloshield.client.model

import moe.gensoukyo.haloshield.client.model.internal.GeneratedShieldPart
import net.minecraft.client.model.ModelBase
import net.minecraft.entity.Entity
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly

@SideOnly(Side.CLIENT)
open class EnergyShieldModel(delegate: ModelBase): ModelBase() {

    companion object {
        val EMPTY_MODEL = EnergyShieldModel(object: ModelBase() {})
    }
    private val parts = ModelPartFinder.findParts(delegate)
        .map { GeneratedShieldPart(this, it) }

    override fun render(
        entityIn: Entity,
        limbSwing: Float,
        limbSwingAmount: Float,
        ageInTicks: Float,
        netHeadYaw: Float,
        headPitch: Float,
        scale: Float
    ) {
        parts.forEach { it.render(scale) }
        super.render(entityIn, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale)
    }
}
