package moe.gensoukyo.haloshield.client.model.internal

import moe.gensoukyo.haloshield.client.model.EnergyShieldPart
import net.minecraft.client.model.ModelBase
import net.minecraft.client.model.ModelRenderer
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly
import java.util.*

/**
 * 侵入式护盾部件
 * 会把原部件的子模型换成对应的部件版本
 * @author ChloePrime
 */
@SideOnly(Side.CLIENT)
open class IntrusiveEShieldPart(
    private val shieldModel: ModelBase,
    private val delegate: ModelRenderer
): EnergyShieldPart(shieldModel, delegate) {

    internal fun replaceChildren(refMap: IdentityHashMap<ModelRenderer, ModelRenderer>) {
        delegate.childModels?.forEach { orig ->
            val child = refMap[orig] ?: IntrusiveEShieldPart(shieldModel, orig).apply {
                this.replaceChildren(refMap)
            }
            this.addChild(child)
        }
    }
}