package moe.gensoukyo.haloshield.client.renderer

import moe.gensoukyo.haloshield.client.model.FallbackEnergyShieldModel
import net.minecraft.entity.EntityLivingBase
import net.minecraftforge.fml.relauncher.Side
import net.minecraftforge.fml.relauncher.SideOnly

@SideOnly(Side.CLIENT)
object SharedRenderers {
    @JvmField
    val BALL_SURROUNDING: RenderEnergyShield<in EntityLivingBase> =
        object : RenderEnergyShield<EntityLivingBase>(
            EntityLivingBase::class.java,
            FallbackEnergyShieldModel()
        ) {
            override fun doRender(
                entity: EntityLivingBase,
                x: Double,
                y: Double,
                z: Double,
                entityYaw: Float,
                partialTicks: Float
            ) {
                val bb = entity.renderBoundingBox
                val realY = y + bb.center.y - entity.posY//  + 4
                super.doRender(entity, x, realY, z, entityYaw, partialTicks)
            }
        }

    @Suppress("UNCHECKED_CAST")
    fun <E : EntityLivingBase> RenderEnergyShield<*>.cast(): RenderEnergyShield<E> {
        return this as RenderEnergyShield<E>
    }
}