package moe.gensoukyo.haloshield.common

import moe.gensoukyo.haloshield.SpartanShieldsMod
import moe.gensoukyo.haloshield.common.api.IShieldData
import net.minecraft.util.ResourceLocation
import net.minecraftforge.common.config.Config
import net.minecraftforge.common.config.ConfigManager
import net.minecraftforge.fml.client.event.ConfigChangedEvent
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent

/**
 * @author ChloePrime
 */
@Config(modid = SpartanShieldsMod.MODID)
@Config.LangKey("${SpartanShieldsMod.MODID}.config.general")
@Mod.EventBusSubscriber(modid = SpartanShieldsMod.MODID)
object ModConfig {
    /**
     * 能量护盾阻止受击击退
     */
    @JvmField
    @Config.Comment("Energy Shield Prevents Knockback")
    var shieldPreventsKnockBack = true

    /**
     * 能量护盾阻止燃烧
     */
    @JvmField
    @Config.Comment("Energy Shield Prevents Burning")
    var shieldPreventsFire = true

    /**
     * 拥有能量护盾时
     * 自动清除以下效果
     */
    @JvmField
    @Config.Comment("Energy Shield Prevents Burning")
    var autoHeal = arrayOf(
        "minecraft:poison",
        "minecraft:wither"
    )

    /**
     * 以 [ResourceLocation] 形式存储的药水列表
     */
    @JvmField
    @Config.Ignore
    var autoHealOopList: Array<ResourceLocation> = arrayOf()
    init {
        compilePotionList()
    }
    private fun compilePotionList() {
        autoHealOopList = autoHeal.map {
            ResourceLocation(it)
        }.toTypedArray()
    }

    @JvmStatic
    @SubscribeEvent
    fun onConfigSync(e: ConfigChangedEvent.OnConfigChangedEvent) {
        if (e.modID == SpartanShieldsMod.MODID) {
            ConfigManager.sync(SpartanShieldsMod.MODID, Config.Type.INSTANCE)
            compilePotionList()
        }
    }

    /**
     * 反转 [IShieldData.isAlwaysShowShield] 的结果
     */
    @JvmField
    @Config.Comment("Inverts 'Always Show Shield' Property")
    var invertAlwaysShowShield = false
}