package moe.gensoukyo.haloshield.common.api;

import moe.gensoukyo.haloshield.SpartanShieldsMod;
import net.minecraft.entity.ai.attributes.IAttribute;
import net.minecraft.entity.ai.attributes.RangedAttribute;

/**
 * 生物属性 (Attribute)
 * @author ChloePrime
 */
public class SpartanShieldAttributes {
    /**
     * 最大护盾容量
     */
    public static final IAttribute MAX_SHIELD_ATTR
            = (new RangedAttribute(null, SpartanShieldsMod.MODID + ".max_shield",
            0.0D, 0D, Float.MAX_VALUE)).setShouldWatch(true);
    /**
     * 护盾恢复速度
     * HP / tick
     */
    public static final IAttribute SHIELD_RECOVER_SPEED
            = (new RangedAttribute(null, SpartanShieldsMod.MODID + ".recover_speed",
            0.5D, 0D, Float.MAX_VALUE));
    /**
     * 护盾恢复延迟
     * 单位 tick
     * 越小越好
     */
    public static final IAttribute SHIELD_RECOVER_DELAY
            = (new RangedAttribute(null, SpartanShieldsMod.MODID + ".recover_delay",
            60D, 0D, Float.MAX_VALUE));
}
