package moe.gensoukyo.haloshield.common.event

import moe.gensoukyo.haloshield.ModIds
import moe.gensoukyo.haloshield.SpartanShieldsMod
import net.minecraft.entity.EntityLivingBase
import net.minecraft.util.DamageSource
import net.minecraftforge.common.util.EnumHelper
import net.minecraftforge.event.entity.living.LivingEvent
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.Optional
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import noppes.npcs.api.IDamageSource
import noppes.npcs.api.NpcAPI
import noppes.npcs.api.entity.ICustomNpc
import noppes.npcs.api.entity.IEntity
import noppes.npcs.api.event.NpcEvent
import noppes.npcs.constants.EnumScriptType
import noppes.npcs.entity.EntityCustomNpc

class ShieldBreakEvent(
    e: EntityLivingBase,
    val source: DamageSource?
): LivingEvent(e)

class ShieldBreakEventCnpc(
    npc: ICustomNpc<*>,
    val damageSource: IDamageSource?,
    val source: IEntity<*>? = damageSource?.trueSource
): NpcEvent(npc)

@Mod.EventBusSubscriber(modid = SpartanShieldsMod.MODID)
object NpcEventDeliverer {
    private val hook = EnumHelper.addEnum(EnumScriptType::class.java, "SHIELD_BREAK",
        arrayOf(String::class.java), "shieldBreak")

    @JvmStatic
    @SubscribeEvent
    @Optional.Method(modid = ModIds.CNPC)
    fun onShieldBreak(e: ShieldBreakEvent) {
        val npc = e.entityLiving
        if (npc !is EntityCustomNpc) {
            return
        }
        val event = ShieldBreakEventCnpc(NpcAPI.Instance().getIEntity(npc) as ICustomNpc<*>,
            e.source?.let { NpcAPI.Instance().getIDamageSource(it) })
        npc.script.runScript(hook, event)
    }
}