package moe.gensoukyo.haloshield.common.event

import moe.gensoukyo.haloshield.ModIds
import moe.gensoukyo.haloshield.SpartanShieldsMod
import net.minecraft.entity.EntityLivingBase
import net.minecraftforge.common.util.EnumHelper
import net.minecraftforge.event.entity.living.LivingEvent
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.common.Optional
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent
import noppes.npcs.api.entity.ICustomNpc
import noppes.npcs.api.event.NpcEvent
import noppes.npcs.constants.EnumScriptType
import noppes.npcs.entity.EntityCustomNpc

class ShieldRecoverEvent(e: EntityLivingBase): LivingEvent(e)

class ShieldRecoverEventCnpc(npc: ICustomNpc<*>): NpcEvent(npc)

@Mod.EventBusSubscriber(modid = SpartanShieldsMod.MODID)
object NpcRecoverShieldEventDeliverer {
    private val hook = EnumHelper.addEnum(EnumScriptType::class.java, "SHIELD_RECOVER",
        arrayOf(String::class.java), "shieldRecover")

    @JvmStatic
    @SubscribeEvent
    @Optional.Method(modid = ModIds.CNPC)
    fun onShieldRecover(e: ShieldRecoverEvent) {
        val npc = e.entityLiving
        if (npc !is EntityCustomNpc) {
            return
        }
        val event = ShieldRecoverEventCnpc(npc.wrappedNPC)
        npc.script.runScript(hook, event)
    }
}