package moe.gensoukyo.haloshield.core.client;

import moe.gensoukyo.haloshield.client.api.IMixinModelRenderer;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

/**
 * 记录部件渲染时的必要数据
 * @see ModelBase
 * @author ChloePrime
 */
@Mixin(ModelRenderer.class)
public class MixinModelRenderer implements IMixinModelRenderer {
    private float lastScale = 0.0625f;
    @Override
    public float getLastScale() {
        return lastScale;
    }

    private boolean shouldRenderShield = false;
    @Override
    public boolean getShouldRenderShield() {
        return shouldRenderShield;
    }
    @Override
    public void setShouldRenderShield(boolean rendered) {
        shouldRenderShield = rendered;
    }

    @Inject(
            method = "render(F)V",
            at = @At("HEAD")
    )
    @SuppressWarnings("AlibabaLowerCamelCaseVariableNaming")
    private void inject_render(float scale, CallbackInfo ci) {
        lastScale = scale;
        shouldRenderShield = true;
    }
}
