package moe.gensoukyo.haloshield.core.client.api;

import net.minecraft.client.renderer.entity.RenderLivingBase;
import net.minecraft.entity.EntityLivingBase;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.gen.Invoker;

/**
 * 允许访问preRenderCallback
 * 以让实体身上的额外模型可以在渲染前调整模型的大小至与原实体一致
 * @author ChloePrime
 */
@Mixin(RenderLivingBase.class)
public interface IRenderPreparationAccessor<E extends EntityLivingBase> {
    /**
     * MC 原版通常拿这个来设置缩放
     * @param entity ~
     * @param partialTickTime ~
     */
    @Invoker void callPreRenderCallback(E entity, float partialTickTime);

    /**
     * 这个方法通常用来设置生物的旋转，使用的是OGL的Transform
     * 所以可以用来设置护盾的旋转
     * @param entityLiving ~
     * @param ageInTicks ~
     * @param rotationYaw ~
     * @param partialTicks ~
     */
    @Invoker void callApplyRotations(E entityLiving, float ageInTicks, float rotationYaw, float partialTicks);
}
