package moe.gensoukyo.scriptap;

import net.minecraftforge.fml.common.eventhandler.Event;
import noppes.npcs.api.NpcAPI;
import noppes.npcs.api.constants.EntityType;
import noppes.npcs.api.entity.IEntity;
import org.bukkit.entity.Entity;
import org.serverct.ersha.jd.AttributeAPI;
import org.serverct.ersha.jd.api.BaseAttribute;
import org.serverct.ersha.jd.attribute.AttributeData;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;


import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @implNote Not a event
 * @author Chloe_koopa
 */
@SuppressWarnings({"unused", "rawtypes"})
public class ApAttributeEvent extends Event {
    public final IEntity<?> damager;
    public final IEntity<?> victim;
    public final Entity craftDamager;
    public final Entity craftVictim;
    public final AttributeData damagerData;
    public final AttributeData victimData;
    public final BaseAttribute attr;
    public final double value;

    public ApAttributeEvent(Entity damager, Entity victim, BaseAttribute attr, double value) {
        this.craftDamager = damager;
        this.craftVictim = victim;
        this.damager = transformEntity(damager);
        this.victim = transformEntity(victim);
        this.attr = attr;

        this.damagerData = AttributeAPI.getAttrData(damager);
        this.victimData = AttributeAPI.getAttrData(victim);

        this.value = value;
    }

    private IEntity<?> transformEntity(Entity entity) {
        return NpcAPI.Instance().getIEntity(EntityTransformer.transform(entity));
    }

    //快捷方法

    public List<IEntity> attackerR(int range, boolean noDamager, boolean noVictim) {
        return ranged(damager, range, noDamager, noVictim);
    }

    public List<IEntity> victimR(int range, boolean noDamager, boolean noVictim) {
        return ranged(victim, range, noDamager, noVictim);
    }

    private List<IEntity> ranged(IEntity<?> entity,
                                           int range,
                                           boolean noDamager,
                                           boolean noVictim) {
        if (entity == null) {
            return Collections.emptyList();
        }
        return Arrays.stream(entity.getWorld().getNearbyEntities(entity.getPos(), range, EntityType.ANY))
                .filter(iEntity -> (!noDamager || (iEntity != damager)) && (!noVictim || (iEntity != victim)))
                .collect(Collectors.toList());
    }
}
